//+------------------------------------------------------------------+
//|                                            Neuer Versuch neu.mq4 |
//|                                                Korbinian Gabriel |
//|                                                                - |
//+------------------------------------------------------------------+
#property copyright "Korbinian Gabriel"
#property link      "-"
#property version   "1.00"
#property strict
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+

/*Idee: Wenn ATR unter bestimmten Wert ist, dann werden Trades sofort auf break even gezogen, sobald es mglich ist;
Aktuell liegt noch ein Fehler im Ordersendverfahren vor*/

//--- Extern variables
extern int Mx=0; 
extern double abst=2.0;
extern int irsi=14;
extern int iboll=20;
extern int st1=10;
extern double st2=3.0;
extern int slippage = 100; 
extern double takeprofit = 0; 
extern double manualsl = 20; 
extern int magicnumber = 1; 

extern double Lots  = 1.0;     

//--- Intern variables
int Oldbar = 0; 
int ordersend,ordermodify; 
int total = OrdersTotal(); 

//--- ACHTUNG HIER KANN EIN FEHLER SEIN: INT STATT DOUBLE LSST FEHLER 3 VERSCHWINDEN!
double stoploss; 

double st1_long;
double st1_short;
double st2_long;
double st2_short;
      
double BBUP;
double BBDN;

double rsi1;
double rsi0;
//--- On expert-advisor initiation
int OnInit()
  {
//---
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
int start()
  {
   if(Oldbar != Bars) {
   


//---Variablen:
      st1_long = iCustom(NULL,0,"SuperTrend1",st1,st2,0,1);
      st1_short = iCustom(NULL,0,"SuperTrend1",st1,st2,1,1);
      st2_long = iCustom(NULL,0,"SuperTrend1",st1,st2,0,2);
      st2_short = iCustom(NULL,0,"SuperTrend1",st1,st2,1,2);
      
      
      BBUP = iBands(NULL,0,iboll,2,2,PRICE_CLOSE,MODE_UPPER,0);
      BBDN = iBands(NULL,0,iboll,2,2,PRICE_CLOSE,MODE_LOWER,0);
      
      rsi1 = iRSI(NULL,0,irsi,PRICE_CLOSE,1);
      rsi0 = iRSI(NULL,0,irsi,PRICE_CLOSE,0); // hier mglicherweise die zahl zu 2 tauschen

//---Stoplossdefinition    
      if(OrderType() == OP_BUY || OrderType() == OP_BUYSTOP) stoploss = st1_long - abst;
      if(OrderType() == OP_SELL || OrderType() == OP_SELLSTOP) stoploss = st1_short + abst; 
      NormalizeDouble(stoploss,Digits());     
       
//--- Trailingstoploss
      if(OrdersTotal() > 0){Trailingstoploss();}
      OpenLongOrderatBBModify();
      OpenShortOrderatBBModify();
      
//--- Closing Trades: 
      if(OrdersTotal() > 0){
         if(rsi1 < 30 && rsi0 > 30)
         {
            ClosingTrades();
         }
         if(rsi1 > 70 && rsi0 < 70)
         {
            ClosingTrades();
         }
       }

//--- Ordercounter
      int ord,i;
      string symbol;
      total = OrdersTotal();
      for(i=0;i<total;i++)
      {
      OrderSelect(i,SELECT_BY_POS);
      if(OrderSymbol() == Symbol()) ord++;
      }
      if(ord>0) return (0); //Abort! A Position For This Pair is Already Open

               
//--- Initializing Orders
      if(long_st() == true){
         if(ord == 0){
            if(Close[1] < BBUP) OpenLongOrderatBB();
            if(Close[1] > BBUP) OpenLongOrderMarket();
         }
      }
      if(short_st() == true){
         if(ord == 0){
            if(Close[1] < BBDN) OpenShortOrderatBB();
            if(Close[1] > BBDN) OpenShortOrderMarket();
         }
      }
      

   
   }
   Oldbar = Bars;    
   return(0);
  }
  
//--- Functions
int anzTradesLong() {
   int ord=0;
   for(int i=0;i<=total-1;i++) {
      if(OrderSelect(i,SELECT_BY_POS)       
         && OrderType() == OP_BUY
         && OrderSymbol() == Symbol())
            ord++;
   }
   return (ord); 
}

int anzTradesShort() {
   int ord=0;
   for(int i=0;i<=total-1;i++) {
      if(OrderSelect(i,SELECT_BY_POS)      
         && OrderType() == OP_SELL
         && OrderSymbol() == Symbol())
            ord++;
   }
   return (ord); 
}

bool long_st(){
   return st1_long < Close[1] && st2_short > Close[2];
   }

bool short_st(){
   return st2_long < Close[2] && st1_short > Close[1];
   }


//Maybe rsi signal for orderopening!!


void OpenLongOrderatBB(){
   new_del();
   ordersend = OrderSend(NULL,OP_BUYSTOP,Lots,NormalizeDouble(BBUP,Digits()),slippage,stoploss*Point,takeprofit,"Open Pending Long Order at upper Bollinger Band",magicnumber,0,Green);
   if(ordersend < 0) Alert("OrderSend ERROR LongOrder at BB NOT opened! ", GetLastError());
   else Print("Opened LongOrder: ",OrderMagicNumber()," on ",OrderSymbol(), "Lots: ",OrderLots()," StopLoss: ",OrderStopLoss()," TakeProfit: ",OrderTakeProfit());

   }

void OpenLongOrderatBBModify(){
      for(int i=0;i<=total-1;i++) {
      if(OrderSelect(i,SELECT_BY_TICKET)       // Part soll dafr sorgen, dass nur 1 Position pro Signal erffnet wird. 
         && OrderType() == OP_BUYSTOP
         && OrderSymbol() == Symbol()
         && OrderCloseTime()==0  //Trailingstop, der auf Basis des SuperTrend Indikators nachgezogen werden soll. (Nur fr Long)
         && OrderType()==OP_BUYSTOP ) {
            if(OrderOpenPrice() < BBUP) {
               ordermodify = OrderModify(OrderTicket(),NormalizeDouble(BBUP,Digits()),stoploss*Point,takeprofit,0);
               if (ordermodify == false)
                  Print("Stoploss ",OrderTicket()," NICHT nachgezogen! ERROR!");
               else
                  Print("StopLoss ",OrderTicket()," nachgezogen");
            }
         }
      }
   }

void OpenShortOrderatBB(){
   new_del();
   ordersend = OrderSend(NULL,OP_SELLSTOP,Lots,NormalizeDouble(BBDN,Digits()),slippage,stoploss*Point,takeprofit,"Open Pending Short Order at lower Bollinger Band",magicnumber,0,Red);
   if(ordersend < 0) Alert("OrderSend ERROR ShortOrder at BB NOT opened! ", GetLastError());
   else Print("Opened ShortOrder: ",OrderMagicNumber()," on ",OrderSymbol(), "Lots: ",OrderLots()," StopLoss: ",OrderStopLoss()," TakeProfit: ",OrderTakeProfit());

   }
   
void OpenShortOrderatBBModify(){
      for(int i=0;i<=total-1;i++) {
      if(OrderSelect(i,SELECT_BY_TICKET)       // Part soll dafr sorgen, dass nur 1 Position pro Signal erffnet wird. 
         && OrderType() == OP_SELLSTOP
         && OrderSymbol() == Symbol()
         && OrderCloseTime()==0  //Trailingstop, der auf Basis des SuperTrend Indikators nachgezogen werden soll. (Nur fr Long)
         && OrderType()==OP_SELLSTOP ) {
            if(OrderOpenPrice() > BBDN) {
               ordermodify = OrderModify(OrderTicket(),NormalizeDouble(BBDN,Digits()),stoploss*Point,takeprofit,0);
               if (ordermodify == false)
                  Print("Stoploss ",OrderTicket()," NICHT nachgezogen! ERROR!");
               else
                  Print("StopLoss ",OrderTicket()," nachgezogen");
            }
         }
      }
   }

void OpenLongOrderMarket(){
   new_del();
   ordersend = OrderSend(NULL,OP_BUY,Lots,NormalizeDouble(Ask,Digits()),slippage,stoploss*Point,takeprofit,"Open Market Long Order",magicnumber,0,Green);
   if(ordersend < 0) Alert("OrderSend ERROR LongOrder NOT opened! ", GetLastError());
   else Print("Opened LongOrder: ",OrderMagicNumber()," on ",OrderSymbol(), "Lots: ",OrderLots()," StopLoss: ",OrderStopLoss()," TakeProfit: ",OrderTakeProfit());
   }

void OpenShortOrderMarket(){
   new_del();
   ordersend = OrderSend(NULL,OP_SELL,Lots,NormalizeDouble(Bid,Digits()),slippage,stoploss*Point,takeprofit,"Open Market Short Order",magicnumber,0,Red);
   if(ordersend < 0) Alert("OrderSend ERROR ShortOrder NOT opened! ", GetLastError());
   else Print("Opened ShortOrder: ",OrderMagicNumber()," on ",OrderSymbol(), "Lots: ",OrderLots()," StopLoss: ",OrderStopLoss()," TakeProfit: ",OrderTakeProfit());
   }

void Trailingstoploss(){
   //--- Trailingstoploss: 
      for(int i=0;i<=total-1;i++) {
      if(OrderSelect(i,SELECT_BY_POS)       // Part soll dafr sorgen, dass nur 1 Position pro Signal erffnet wird. 
         && OrderType() == OP_BUY
         && OrderSymbol() == Symbol()
         && OrderCloseTime()==0) {
            if(OrderStopLoss()<stoploss) {
               ordermodify = OrderModify(OrderTicket(),OrderOpenPrice(),stoploss*Point,takeprofit,0);
               if (ordermodify == false)
                  Print("Stoploss ",OrderTicket()," NICHT nachgezogen! ERROR!");
               else
                  Print("StopLoss ",OrderTicket()," nachgezogen");
            }
         }
      }
      
      for(int i=0;i<=total-1;i++) {
      if(OrderSelect(i,SELECT_BY_POS)       // Part soll dafr sorgen, dass nur 1 Position pro Signal erffnet wird. 
         && OrderType() == OP_SELL
         && OrderSymbol() == Symbol()
         && OrderCloseTime()==0) {
            if(OrderStopLoss() > stoploss) {
               ordermodify = OrderModify(OrderTicket(),OrderOpenPrice(),stoploss*Point,takeprofit,0);
               if (ordermodify == false)
                  Print("Stoploss ",OrderTicket()," NICHT nachgezogen! ERROR!");
               else
                  Print("StopLoss ",OrderTicket()," nachgezogen");
            }
         }
      }            

      for(int i=0;i<=total-1;i++) {
      if(OrderSelect(i,SELECT_BY_POS)       // Part soll dafr sorgen, dass nur 1 Position pro Signal erffnet wird. 
         && OrderType() == OP_BUYSTOP
         && OrderSymbol() == Symbol()
         && OrderCloseTime()==0) {
            if(OrderStopLoss()<stoploss) {
               ordermodify = OrderModify(OrderTicket(),OrderOpenPrice(),stoploss*Point,takeprofit,0);
               if (ordermodify == false)
                  Print("Stoploss ",OrderTicket()," NICHT nachgezogen! ERROR!");
               else
                  Print("StopLoss ",OrderTicket()," nachgezogen");
            }
         }
      }
      
      for(int i=0;i<=total-1;i++) {
      if(OrderSelect(i,SELECT_BY_POS)       // Part soll dafr sorgen, dass nur 1 Position pro Signal erffnet wird. 
         && OrderType() == OP_SELLSTOP
         && OrderSymbol() == Symbol()
         && OrderCloseTime()==0) {
            if(OrderStopLoss() > stoploss) {
               ordermodify = OrderModify(OrderTicket(),OrderOpenPrice(),stoploss*Point,takeprofit,0);
               if (ordermodify == false)
                  Print("Stoploss ",OrderTicket()," NICHT nachgezogen! ERROR!");
               else
                  Print("StopLoss ",OrderTicket()," nachgezogen");
            }
         }
      }            
}

void ClosingTrades(){
   //--- Closing Orders
         for(int i=0;i<=total-1;i++) {
            if(OrderSelect(i,SELECT_BY_POS)) { // Part soll dafr sorgen, dass nur 1 Position pro Signal erffnet wird. 
               if(OrderCommission()+OrderProfit()+OrderSwap()>0) {
                  Print ("Order closing now, because of RSI-Signal!");
                  bool result = OrderClose(OrderSelect(OrderTicket(), SELECT_BY_POS),OrderLots(),Ask,10); //Komisch: Wenn ich SELECT_BY_TICKET auswhle, funktioniert der Trailingstop nicht
                  if (result == true)
                     Print ("Orderclosing ",OrderTicket()," succeeded");
                  else
                     Print ("Orderclosing ",OrderTicket()," failed");
               }
            }
         }
      
      
         for(int i=0;i<=total-1;i++) {
            if(OrderSelect(i,SELECT_BY_POS)) { // Part soll dafr sorgen, dass nur 1 Position pro Signal erffnet wird. 
               if(OrderCommission()+OrderProfit()+OrderSwap()>0) {
                  Print ("Order closing now, because of RSI-Signal!");
                  bool result = OrderClose(OrderSelect(OrderTicket(), SELECT_BY_TICKET),OrderLots(),Bid,10); //Komisch: Wenn ich SELECT_BY_TICKET auswhle, funktioniert der Trailingstop nicht
                  if (result == true)
                     Print ("Orderclosing ",OrderTicket()," succeeded");
                  else
                     Print ("Orderclosing ",OrderTicket()," failed");
               }
            }
         }
      
      if(OrderType() == OP_BUY || OrderType() == OP_BUYSTOP){
         if(short_st() == true){
            for(int i=0;i<=total-1;i++) {
               if(OrderSelect(i,SELECT_BY_POS)) { // Part soll dafr sorgen, dass nur 1 Position pro Signal erffnet wird. 
                  if(OrderCommission()+OrderProfit()+OrderSwap()>0) {
                     Print ("Order closing now, because of RSI-Signal!");
                     bool result = OrderClose(OrderSelect(OrderTicket(), SELECT_BY_POS),OrderLots(),Ask,10); //Komisch: Wenn ich SELECT_BY_TICKET auswhle, funktioniert der Trailingstop nicht
                     if (result == true)
                        Print ("Orderclosing ",OrderTicket()," succeeded");
                     else
                        Print ("Orderclosing ",OrderTicket()," failed");
                  }
               }
            }
         }
      }
      if(OrderType() == OP_SELL || OrderType() == OP_SELLLIMIT){
         if(long_st() == true){
            for(int i=0;i<=total-1;i++) {
               if(OrderSelect(i,SELECT_BY_POS)) { // Part soll dafr sorgen, dass nur 1 Position pro Signal erffnet wird. 
                  if(OrderCommission()+OrderProfit()+OrderSwap()>0) {
                     Print ("Order closing now, because of RSI-Signal!");
                     bool result = OrderClose(OrderSelect(OrderTicket(), SELECT_BY_POS),OrderLots(),Bid,10); //Komisch: Wenn ich SELECT_BY_TICKET auswhle, funktioniert der Trailingstop nicht
                     if (result == true)
                        Print ("Orderclosing ",OrderTicket()," succeeded");
                     else
                        Print ("Orderclosing ",OrderTicket()," failed");
                  }
               }
            }
         }
      }      

}

//---Delete Pending Orders
int new_del()
 {
    int i,a;
    string comentario,par;
    for (i=total-1; i >=0; i--)
    {
       OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
       if (OrderType()==OP_BUY || OrderType()==OP_SELL)
       {
          for (a=total-1; a >=0; a--)
          {
             OrderSelect(a,SELECT_BY_POS,MODE_TRADES);
             comentario=OrderComment();
             par=StringSubstr(comentario,0,6); 
             if(OrderType()==OP_SELLSTOP)// && comentario==Symbol())
             {
                OrderDelete(OrderTicket());
                Print("Deleting SELL_STOP"," Ordertype:",OrderType());
                return(1);
             }
             if(OrderType()==OP_BUYSTOP)// && par==Symbol())
             {
                OrderDelete(OrderTicket());
                Print("Deleting BUY_STOP"," Ordertype:",OrderType());
                return(1);
             }
          }
       }
    }
 return(1);
 }
//+------------------------------------------------------------------+
